<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="实验室名称:">
                <Input v-model="formObj.name" @on-enter="_formSearch" name="name" placeholder="请输入实验室名称" clearable/>
              </Form-item>
              <Form-item class="search-item" label="资质:">
                <Input v-model="formObj.aptitude" @on-enter="_formSearch" name="aptitude" placeholder="请输入资质" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                     class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange" select-data>
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <operationModal ref="operationModal"></operationModal>
    <FileManage ref="FileManage"></FileManage>
  </div>

</template>
<script>
import { meterSample } from '../../../api'
import operationModal from '../../../components/operation/Operation'
export default {
  components: { operationModal },
  data() {
    return {
      currentComponent: '',
      formId: 'meterCertificateCheckFormId',
      searchOpen: false,
      btn: [
        {
          type: 'success',
          id: '',
          name: '生成'
        }
      ],
      iconMsg: [
        {
          type: 'md-create',
          id: '',
          name: '编辑'
        },
        {
          type: 'md-car',
          id: '',
          name: '车辆管理'
        },
        {
          type: 'ios-list-box',
          id: '',
          name: '仪器领用'
        },
        { type: 'md-cloud', id: '', name: '附件' },
        { type: 'md-remove-circle', id: '', name: '删除' },
        {
          type: 'ios-clock',
          id: '',
          name: '操作日志'
        }
      ],
      formObj: {
        name: undefined,
        aptitude: undefined
      },
      selectIds: [],
      selectData: [],
      getPage: {},
      pageColumns: [
        { title: '样品名称', key: 'name', width: 120 },
        { title: '样品编号', key: 'code', width: 120 },
        { title: '型号规格', key: 'spec', width: 100 },
        { title: '证书是否生成', key: 'reported', width: 120 },
        { title: '出厂编号', key: 'factoryNumber' },
        { title: '检测类型', key: 'type' },
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '数量', key: 'quantity' },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _modalResult() {
      if (this.currentComponent === 'FoodSubcontracterEdit') {
        this._page()
      }
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '生成':
            this._create()
            break
          case '添加':
            this._editModal(false)
            break
          case '提交':
            this._submitToReview()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _submitToReview() {
      this._submitByContractIds('委托评审')
    },
    _submitByContractIds(cont) {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要把这 ' + ids.length + ' 条记录提交到' + cont + '？',
          onOk: () => {
            const result = meterSample.submit(ids)
            if (result) {
              console.log(result)
            }
          }
        })
      }
    },
    _create() {
      const selectData = JSON.parse(JSON.stringify(this.selectData))
      console.log(selectData)
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.CreateReport._open(this.selectData)
      }
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编辑':
            // this._editModal(true, data.id)
            this._personModal(data)
            break
          case '资质项目':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _personModal(data) {
      console.log(data)
      this.$refs.personModal._open(data.id)
    },
    _record(id) {
      this.$refs.operationModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          console.log('操作按钮点击后的值', data)
          break
        // case 'selectIds':
        //   this.selectIds = data
        //   console.log('操作按钮点击后的值', data)
        //   break
        case 'selectData':
          this.selectData = data
          this.selectIds = []
          for (let i = 0; i < data.length; i++) {
            this.selectIds.push(data[i].id)
          }
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await meterSample.pageCertificateMake(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },
    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _getById: async function(id) {
      const result = await meterSample.getById(id)
      if (result) {
        this.$refs.editSubcontractorModal._openEdit(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSample.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
